#!/usr/sbin/dtrace -s
#pragma D option quiet

syscall::forksys:return
/ $target == pid /
{
    t = 1;
}

fbt::fsig:entry
/ t && progenyof($target) && \
  (args[0]->__sigbits[0] > 0 \
   || args[0]->__sigbits[1] > 0 \
   || args[0]->__sigbits[2] > 0) /
{
    printf("USER STACK:");
    ustack();
    printf("=> fsig(k_sigset_t: {%u, %u, %u}, ...), ",
           args[0]->__sigbits[0],
           args[0]->__sigbits[1],
           args[0]->__sigbits[2]);
    printf("kthread_t->t_hold {%u, %u, %u}\n",
           args[1]->t_hold.__sigbits[0],
           args[1]->t_hold.__sigbits[1],
           args[1]->t_hold.__sigbits[2]);
    this->tt = 1;
}

fbt::fsig:return
/ t && progenyof($target) && this->tt /
{
    printf("<= fsig returned signal: %d\n", args[1]);
    this->tt = 0;
}

syscall::lwp_sigmask:entry
/ t && progenyof($target) /
{
    printf("=> lwp_sigmask(%d, %u, %u, %u)\n", arg0, arg1, arg2, arg3);
}

syscall::lwp_sigmask:return
/ t && progenyof($target) /
{
    printf("<= lwp_sigmask returned, t_sig_check: %d, ",
           curthread->_tu._ts._t_sig_check);
    printf("kthread_t->t_hold {%u, %u, %u}\n",
           curthread->t_hold.__sigbits[0],
           curthread->t_hold.__sigbits[1],
           curthread->t_hold.__sigbits[2]);

}
